# Отчёт по лабораторной работе №2

Выполнил: студентка гр. ИСЭбд-41, Гренадерова А.А.

Вариант программы 1: 1. Ищет в каталоге /var/data файл с наибольшим количеством строк и перекладывает его в /var/result/data.txt.

Вариант программы 2: 2. Ищет наименьшее число из файла /var/data/data.txt и сохраняет его третью степень в /var/result/result.txt.

## Создание приложений

Создадим 2 приложения.
Был выбран язык C# и технология .NET 5.

Для создания обычных консольных приложений воспользуемся командами:

```sh
dotnet new console -o worker-1
dotnet new console -o worker-2
```

Согласно варианту, программа 1 должна найти в каталоге /var/data файл с наибольшим количеством строк и переложить его в /var/result/data.txt.

[Исходный текст программы worker-1](worker-1/Program.cs)

Согласно варианту программа 2 должна найти наименьшее число из файла /var/data/data.txt и сохранить его третью степень в /var/result/result.txt.

[Исходный текст программы worker-2](worker-2/Program.cs)

Дополнительно создан файл [.gitignore](.gitignore) для того, чтобы не закоммитить в git ничего лишнего.

## Настройка окружения

Для связи двух приложений воспользуемся следующей схемой:

1. Каталог `./data` должен быть примонтирован в каталог `/var/data` для программы 1.
   Оттуда будут браться исходные данные.
2. Каталог `./result-1` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складываться промежуточные данные.
3. Каталог `./result-1` также должен быть примонтирован в каталог `/var/data` для программы 2.
   Оттуда будут браться промежуточные результаты.
4. Каталог `./result` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складывать результаты финальной обработки.

Для каждой программы были созданы файлы Dockerfile ([программа 1](worker-1/Dockerfile), [программа 2](worker-2/Dockerfile)) с подробным описанием процесса сборки.

Был создан файл [docker-compose.yml](docker-compose.yml), в котором указан манифест для запуска распределённого приложения.


## Сборка и запуск

1. В каталог `./data` помещены 3 файла с различной длиной названия и содержимым.

![](2lab/1.png)

На выходе программа должна записать файл data.txt, как самый длинный по количеству строк.

![](2lab/2.png)

2. Теперь, обрабатывая этот файл:

![](2lab/2.png)

На выходе программа должна записать число 1212 в 3 степени в `./result` так как в файле c названием data.txt оно минимальное.

![](2lab/3.png)

Для запуска приложения необходимо ввести команду `docker compose up --build`.
Результат запуска после сборки:

```
[+] Running 2/0
 ✔ Container lab_2-worker-1-1  Created                                                                                                                                                               0.0s
 ✔ Container lab_2-worker-2-1  Created                                                                                                                                                               0.0s
Attaching to lab_2-worker-1-1, lab_2-worker-2-1
lab_2-worker-1-1  | Файл успешно создан: ../var/result/data.txt
lab_2-worker-2-1  | The maximum number is: 8
lab_2-worker-2-1  | The count of maximum numbers is: 2
lab_2-worker-1-1 exited with code 0
lab_2-worker-2-1 exited with code 0
```

В результате в каталоге `./result` создался файл `result.txt` с содержимым `1780360128`, что соответствует входным данным.

Изменение значений в файлах из каталога `./data` также изменяет содержимое в файлах из каталогов `./result-1` и `./result`.