﻿using System;
using System.IO;

class Program
{
    static void Main(string[] args)
    {
        string sourceDirectory = "/var/data";
        string destDirectory = "/var/result";
        string destFile = Path.Combine(destDirectory, "data.txt");

        // Получаем все файлы в исходном каталоге
        string[] files = Directory.GetFiles(sourceDirectory);

        int maxLines = 0;
        string filePath = "";

        foreach (string file in files)
        {
            // Считываем строки из файла
            string[] lines = File.ReadAllLines(file);

            // Проверяем количество строк в файле
            if (lines.Length > maxLines)
            {
                maxLines = lines.Length;
                filePath = file;
            }
        }

        // Копируем файл с наибольшим количеством строк в новое место
        if (!string.IsNullOrEmpty(filePath))
        {
            File.Copy(filePath, destFile, true);
            Console.WriteLine($"Файл с наибольшим количеством строк перекладывается в {destFile}");
        }
        else
        {
            Console.WriteLine("Файлы не найдены в исходном каталоге");
        }
    }
}
