﻿using System;
using System.IO;

class Program
{
    static void Main(string[] args)
    {
        string sourceFile = "/var/data/data.txt";
        string resultFile = "/var/result/result.txt";

        // Считываем числа из файла
        string[] lines = File.ReadAllLines(sourceFile);
        
        // Переменная для хранения наименьшего числа
        int smallestNumber = int.MaxValue;

        // Проходимся по всем числам в файле
        foreach (string line in lines)
        {
            if (int.TryParse(line, out int number))
            {
                // Если число меньше текущего наименьшего, обновляем значение
                if (number < smallestNumber)
                {
                    smallestNumber = number;
                }
            }
        }

        // Возведение в третью степень
        double result = Math.Pow(smallestNumber, 3);

        // Записываем результат в файл
        File.WriteAllText(resultFile, result.ToString());

        Console.WriteLine("Наименьшее число из файла data.txt возведено в третью степень и сохранено в файле result.txt");
    }
}
